
<%@page import="java.net.URL"%>
<%@page import="es.caib.signatura.api.Signature"%>
<%@page import="es.caib.signatura.api.PDFParser"%>
<%@page import="es.caib.signatura.api.Signer"%>
<%@page import="es.caib.signatura.impl.CAIBSigner"%><%
	java.io.InputStream in = null;	
	java.io.ObjectInputStream oin = null;
	java.io.InputStream vin = null;	
	
	boolean verified=false;
	
try {
	//inicializamos el sistema de firma
	//necesario para que se carguen los servicios de criptografa de BouncyCastle, y se habilite el acceso a las clases privadas
	Signer s=new CAIBSigner();
	
	//recuperamos el inputstream
	in = request.getInputStream ();
	

	
	//verificamos los certificados y su estado de revocacin
	//FIXME el contenttype application/signaturaTest es de pruebas y no admiiido en produccin
	PDFParser parser=s.getPDFParser(in, "application/signaturaTest");
	Signature[] signatures=parser.getSignatures();
	
	for(int i=0;i<signatures.length;i++){
		URL originalDocumentURL=new URL("http://www.caib.es/signaturacaib/docum/doc_pruebas.pdf");
		if(!signatures[i].verify(originalDocumentURL.openStream())) throw new ServletException("El contenido del documento firmado no se corrresponde al documento original");
		System.out.println("firma vlida: "+signatures[i].getParsedCertificate().getName());

		if(!signatures[i].verify())throw new ServletException("La firma no es vlida: "+signatures[i].getParsedCertificate().getName());
		System.out.println("certificados de la firma vlidos: "+signatures[i].getParsedCertificate().getName());
	}
	
	

} catch (Throwable t) {
	//si hay cualquier error que impide la verificacin de la firma, lanzamos una excepcin para que al applet le llegue un estatus http 500 por ejemplo y sepa que la firma no ha sido recibida con xito
	System.err.println ("ERROR ");
	t.printStackTrace ();
	throw new ServletException(t);
}finally{
	if(oin!=null)
		try{
			oin.close ();
		}catch(Throwable t){}
	if(in!=null)
		try{
			in.close ();
		}catch(Throwable t){}
	if(vin!=null)
		try{
			vin.close ();
		}catch(Throwable t){}
	
}
%>