
<%@page import="java.io.ByteArrayInputStream"%>
<%@page import="es.caib.signatura.api.Signature"%>
<%@page import="es.caib.signatura.api.SMIMEParser"%>
<%@page import="es.caib.signatura.api.Signer"%>
<%@page import="es.caib.signatura.impl.CAIBSigner"%><%
	java.io.InputStream in = null;	

	boolean verified=false;
	
try {
	//inicializamos el sistema de firma
	//necesario para que se carguen los servicios de criptografa de BouncyCastle, y se habilite el acceso a las clases privadas
	Signer signer=new CAIBSigner();
	
	//recuperamos el inputstream
	in = request.getInputStream ();
	
	SMIMEParser parser=signer.getSMIMEParser(in);
	boolean validSMIME=true;
	byte document[]=(byte [])parser.getSignedObject();
	Signature signatures[]=parser.getSignatures();
	int i=0;
	for(i=0;i<signatures.length;i++){
		boolean validSignature=signatures[i].verify(new ByteArrayInputStream(document));
		validSMIME=validSMIME && validSignature;
	}
	if(!validSMIME) throw new Exception("Received SMIME with invalid signatures");
} catch (Throwable t) {
	//si hay cualquier error que impide la verificacin de la firma, lanzamos una excepcin para que al applet le llegue un estatus http 500 por ejemplo y sepa que la firma no ha sido recibida con xito
	System.err.println ("ERROR ");
	t.printStackTrace ();
	throw new ServletException(t);
}finally{

	if(in!=null)
		try{
			in.close ();
		}catch(Throwable t){}
	
}
%>