package es.caib.signatura.client.applet;

import java.io.File;
import java.io.FileWriter;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.io.Writer;
import java.util.Date;


public class SigDebug {
	public static final String NL = "\n";
	
	public static boolean isActive(){
		return true;
	}
	/**
	 * Escribe el mensaje de debug al log correspondiente.
	 * 
	 * @param msg Mensaje a escribir.
	 */
	public static void debug( String msg ) {
		String formatted="["+new Date().toString()+"] DEBUG: ["+Thread.currentThread().getName()+"] : "+msg ;
		System.err.println( formatted);
		
	}
	
	/**
	 * Escribe el mensaje de debug al log correspondiente.
	 * 
	 * @param msg Mensaje a escribir.
	 */
	public static void info( String msg ) {
		String formatted="["+new Date().toString()+"] INFO: ["+Thread.currentThread().getName()+"] : "+msg ;
		System.err.println( formatted);
	}
	

	public static void error(Throwable ex) {
		String formatted="["+new Date().toString()+"] ERROR: ["+Thread.currentThread().getName()+"] : "+ex.getMessage() ;
		ex.printStackTrace();
	}
	

}
